
//
// Trust Design LLC : SECS/HSMS Communication library
//
// (c) Copyright Trust Design LLC.  2010-2020.  All rights reserved.
//

#include		"stdafx.h"
#include		"TDSSample2.h"
#include		"TDSSample2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



/////////////////////////////////////////////////////////////////////////////
// CTDSSample2Proc の各関数が本クラスの表示領域に、メッセージを出力するため
// の関数。

CTDSSample2Dlg		*pDlg;			// 本 CLASS インスタンスは唯一である、と
CWinThread			*pThread;		// いう前提のもと、便宜的に、ここに本
									// CLASS インスタンスへのポインタ及び
									// メッセージ表示スレッドのポインタを
									// 確保する。

void	XXPrintf(char *form, ...)
{
	va_list		va;
	char		str[1024],*p;
	int			sz;

	va_start(va,form);
	_vsnprintf_s(str,sizeof(str)-2,_TRUNCATE,form,va);
	va_end(va);

  //pDlg->AddList(str);				// Winodw への表示ではなく、表示スレッド
									// へメッセージを送出しておしまい。
	p=(char*)malloc(sz=(int)(strlen(str)+1));
	strcpy_s(p,sz,str);
	PostThreadMessage(pThread->m_nThreadID,WM_DISPMSSG,(WPARAM)p,0);
}



/////////////////////////////////////////////////////////////////////////////
// 本クラスのメッセージ表示領域へのメッセージ表示を Windows メッセージで
// 受付、AddList() により表示するワーカスレッド
// 表示領域への表示は、SECS メッセージの送信時、受信時が主としたものとなるが、
// それらの表示が混在しないようにロック制御を行う。送信時の表示は、画面制御
// と同一のスレッドで行うため、ロック制御により受信メッセージの表示中に送信
// メッセージの表示が発生し、送信メッセージの表示が停止すると、結果として
// 画面制御スレッドが停止し、画面表示ができないため、受信スレッドも停止する
// というデッドロックになる。それを避けるため、表示メッセージを Windows 
// メッセージで送信することにより、表示待ちを無くし、デッドロックを避ける。
// 本スレッドを Windows メッセージを受け取り、表示するためのスレッドで、本
// ＡＰ起動（本クラスの生成）と伴に起動し、終了しない。
// メッセージは PostMessage() で送信され、表示文字列を格納した領域は送信側で
// malloc() しているので、処理終了後、ここで free() する必要がある。

static UINT
DispText(
LPVOID				par)
{
	CTDSSample2Dlg	*pt;
	MSG				msg;

	pt=(CTDSSample2Dlg*)par;
	for(;;){
		if(GetMessage(&msg,NULL,WM_DISPMSSG,WM_DISPMSSG)	<=0) break;
		pt->AddList((char*)msg.wParam);
		free((void*)msg.wParam);
	}
	AfxEndThread(0);
	return(0);
}



/////////////////////////////////////////////////////////////////////////////
// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

protected:
	DECLARE_MESSAGE_MAP()
};


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CTDSSample2Dlg ダイアログ

CTDSSample2Dlg::CTDSSample2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTDSSample2Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	pDlg			= this;			// XXPrintf() のためのポインタを確保
	m_cWinSize.cx	= 0;
	m_cWinSize.cy	= 0;
	m_Thread		= 0;
	m_iPType		= 0;
	m_Stop			= 0;
}


void CTDSSample2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control	(pDX, IDC_EDIT1		, m_cEditList);
	DDX_Control	(pDX, IDC_EDIT2		, m_cEditMssg);
	DDX_Control	(pDX, IDC_BUTTON1	, m_cBtnStart);
	DDX_Control	(pDX, IDC_BUTTON6	, m_cBtnSend1);
	DDX_Control	(pDX, IDC_BUTTON7	, m_cBtnSend2);
	DDX_Control	(pDX, IDC_BUTTON9	, m_cBtnSend3);
	DDX_Control	(pDX, IDC_BUTTON10	, m_cBtnSend4);
	DDX_Control	(pDX, IDC_BUTTON8	, m_cBtnSendC);
	DDX_Control	(pDX, IDC_RADIO1	, m_cPType0);
	DDX_Control	(pDX, IDC_RADIO2	, m_cPType1);
	DDX_Control	(pDX, IDC_STATIC4	, m_cStaStat);
	DDX_Text	(pDX, IDC_EDIT2		, m_cStrMssgName);
	DDX_Radio	(pDX, IDC_RADIO1	, m_iPType);
}


BEGIN_MESSAGE_MAP(CTDSSample2Dlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDCANCEL		, &CTDSSample2Dlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON1	, &CTDSSample2Dlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_BUTTON6	, &CTDSSample2Dlg::OnBnClickedSend1)
	ON_BN_CLICKED(IDC_BUTTON7	, &CTDSSample2Dlg::OnBnClickedSend2)
	ON_BN_CLICKED(IDC_BUTTON9	, &CTDSSample2Dlg::OnBnClickedSend3)
	ON_BN_CLICKED(IDC_BUTTON10	, &CTDSSample2Dlg::OnBnClickedSend4)
	ON_BN_CLICKED(IDC_BUTTON8	, &CTDSSample2Dlg::OnBnClickedSendC)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CTDSSample2Dlg メッセージ ハンドラ

BOOL CTDSSample2Dlg::OnInitDialog()
{
	CMenu		*pSysMenu;
	CRect		rect;
	CString		strAboutMenu;

	CDialog::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT( IDM_ABOUTBOX < 0xF000);

	pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL){
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()){
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。

	GetClientRect(rect);
	m_cWinSize.cx = rect.Width ();
	m_cWinSize.cy = rect.Height();

	m_cEditList.Init(10000, 1000);

	m_sp			= 0;
	m_iPType		= 0;
	m_cStrMssgName	= _T("");
	m_cStaStat		.SetWindowText("非接続");
	m_cBtnSend1		.EnableWindow(FALSE);
	m_cBtnSend2		.EnableWindow(FALSE);
	m_cBtnSend3		.EnableWindow(FALSE);
	m_cBtnSend4		.EnableWindow(FALSE);
	m_cBtnSendC		.EnableWindow(FALSE);
	m_cEditMssg		.EnableWindow(FALSE);

	UpdateData(FALSE);
	pThread=AfxBeginThread(DispText,(LPVOID)this);

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}


BOOL CTDSSample2Dlg::PreTranslateMessage(MSG *pMsg)
{
	switch(pMsg->message){
		case WM_KEYDOWN:
			switch(pMsg->wParam){
				case VK_ESCAPE:		return TRUE;
				case VK_RETURN:		return TRUE;
			}
			break;
	}

	return CDialog::PreTranslateMessage(pMsg);
}


void CTDSSample2Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX){
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}else{
		CDialog::OnSysCommand(nID, lParam);
	}
}


// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CTDSSample2Dlg::OnPaint()
{
	if (IsIconic()){
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width()  - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}else{
		CDialog::OnPaint();
	}
}


// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CTDSSample2Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTDSSample2Dlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	lpMMI->ptMinTrackSize.x = 320;
	lpMMI->ptMinTrackSize.y = 240;

	CDialog::OnGetMinMaxInfo(lpMMI);
}


void CTDSSample2Dlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	if(m_cWinSize.cx == 0)				return;

	CRect		rect;
	int			dx, dy;

	dx = cx - m_cWinSize.cx;
	dy = cy - m_cWinSize.cy;

	m_cEditList.GetWindowRect(&rect);
	ScreenToClient(&rect);
	rect.right  += dx;
	rect.bottom += dy;
	m_cEditList.SetWindowPos(NULL, 0, 0, rect.Width(), rect.Height(), SWP_NOZORDER | SWP_NOMOVE);

	m_cWinSize.cx = cx;
	m_cWinSize.cy = cy;
}



/////////////////////////////////////////////////////////////////////////////
// 終了処理
// CTDSSample2Proc 生成済みの場合、そのインスタンスを開放する。

void CTDSSample2Dlg::OnBnClickedCancel()
{
	AddList("終了中･･･");
	if(m_Thread	!=0){	m_Stop=1;
		if(WaitForSingleObject(m_Thread->m_hThread,5000)==WAIT_TIMEOUT){
			TerminateThread	  (m_Thread->m_hThread,~0x00);
	}	}				m_Thread=0;
	if(m_sp		!=0)	OnBnClickedStart();
	OnCancel();
}



/////////////////////////////////////////////////////////////////////////////

#define		TERM_TIMER_ID		1

void CTDSSample2Dlg::OnTimer(UINT_PTR nIDEvent)
{
	KillTimer(TERM_TIMER_ID);
	OnBnClickedStart();
}



/////////////////////////////////////////////////////////////////////////////
// 処理開始／処理終了 ボタン処理

void CTDSSample2Dlg::OnBnClickedStart()
{
	CTDSSample2Proc	*p_sp;

	UpdateData(TRUE);

	if(m_sp==0){
		m_sp = new CTDSSample2Proc();
		m_sp->Initialize(m_iPType);
		m_cBtnStart			.SetWindowText("処理終了");
		m_cPType0			.EnableWindow(FALSE);
		m_cPType1			.EnableWindow(FALSE);
		if(m_iPType==0){
			m_cBtnSend2		.SetWindowText("S6F11 送信");
		}else{
			m_cBtnSend2		.SetWindowText("S2F49 送信");
		}
		CheckStatusStart();

	}else{
		CheckStatusStop();
		if(m_sp->Terminate()< 0){
							// ロックに失敗して終了した場合は、100ms 後に
							// 再度処理を試みる。
			SetTimer(TERM_TIMER_ID,100,NULL);
		}else{				// ロック成功し、終了処理を実行した場合は、
							// 画面上の終了処理を行う。
			p_sp=m_sp;		// 処理終了時に m_sp を使用した現在状態表示を
			m_sp=0;			// 行うためのスレッド CheckStatus() での異常終了
							// を避けるため、一旦 p_sp をコピーし、m_sp を
							// =0 とする。m_sp の delete は、時間を置いてから
							// 行う。
			m_cBtnStart			.SetWindowText("処理開始");
			m_cStaStat			.SetWindowText("非接続");
			m_cPType0			.EnableWindow(TRUE);
			m_cPType1			.EnableWindow(TRUE);
			m_cBtnSend1			.EnableWindow(FALSE);
			m_cBtnSend2			.EnableWindow(FALSE);
			m_cBtnSend3			.EnableWindow(FALSE);
			m_cBtnSend4			.EnableWindow(FALSE);
			m_cBtnSendC			.EnableWindow(FALSE);
			m_cEditMssg			.EnableWindow(FALSE);
			Sleep(100);			delete p_sp;

		}
		UpdateData(FALSE);
	}
}



/////////////////////////////////////////////////////////////////////////////
// SECS メッセージ送信処理

void CTDSSample2Dlg::OnBnClickedSend1()
{
	m_sp->SendS1F1();
}


void CTDSSample2Dlg::OnBnClickedSend2()
{
	if(m_iPType==0)			m_sp->SendS6F11();
	else					m_sp->SendS2F49();
}


void CTDSSample2Dlg::OnBnClickedSend3()
{
	char		name[64];

	UpdateData(TRUE);
	strcpy_s(name,sizeof(name),m_cStrMssgName);
	m_sp->SendNamedMssg(name);
}


void CTDSSample2Dlg::OnBnClickedSend4()
{
	m_sp->SendS1F21();
}



/////////////////////////////////////////////////////////////////////////////
// SECS メッセージの連続送信処理開始／停止指示

void CTDSSample2Dlg::OnBnClickedSendC()
{
	if(m_sp->GetCRun()==0)	m_sp->ContSendStart();
	else					m_sp->ContSendStop();
}



/////////////////////////////////////////////////////////////////////////////
// CTDSSampleProc 内の現在の接続状態、及び連続送信処理実行状態を監視し、各
// ボタンの有効性、及びラベルを設定する。
// 本関数は、ワーカスレッドとして動作する。

static UINT
CheckStatus(
LPVOID				par)
{
	CTDSSample2Dlg	*pt;
	int				stat0,stat1=(-1),run0,run1=(-1),ok;

	pt=(CTDSSample2Dlg*)par;
	for(pt->m_Stop=0;pt->m_Stop==0;){
		Sleep(100);		ok=FALSE;
			// 本スレッドでは、TDS 処理を継続していて pt->m_sp が有効である
			// 場合のみ、以下の処理を行わなければいけないので、TDS の終了処理
			// とでロック処理を行う必要があるが、本サンプルではその処理を割愛
			// し、ポインタの有効性のみのチェックを行う。
		if(pt->m_sp							==0)		continue;
		if((stat0=pt->m_sp->GetStatus())	!=stat1){
			switch(stat0){
				case 0:	ok=FALSE;	break;
				case 1: ok=FALSE;	break;
				case 2: ok=TRUE;	break;
			}
			if(ok)	pt->m_cStaStat	.SetWindowText("接続");
			else	pt->m_cStaStat	.SetWindowText("非接続");
			pt->m_cBtnSendC			.EnableWindow(ok);
			if(ok && pt->m_sp->GetCRun()!=0)	ok=FALSE;
			pt->m_cBtnSend1			.EnableWindow(ok);
			pt->m_cBtnSend2			.EnableWindow(ok);
			pt->m_cBtnSend3			.EnableWindow(ok);
			pt->m_cBtnSend4			.EnableWindow(ok);
			pt->m_cEditMssg			.EnableWindow(ok);
			stat1=stat0;
		}
		if(pt->m_sp							==0)		continue;
		if((run0=pt->m_sp->GetCRun())		!=run1){
			if(run0==0){			ok=TRUE;
				pt->m_cBtnSendC		.SetWindowText("連続送信開始");
			}else{					ok=FALSE;
				pt->m_cBtnSendC		.SetWindowText("連続送信終了");
			}
			if(ok && pt->m_sp->GetStatus()!=2)	ok=FALSE;
			pt->m_cBtnSend1			.EnableWindow(ok);
			pt->m_cBtnSend2			.EnableWindow(ok);
			pt->m_cBtnSend3			.EnableWindow(ok);
			pt->m_cBtnSend4			.EnableWindow(ok);
		  //pt->m_cBtnSendC			.EnableWindow(ok);
			pt->m_cEditMssg			.EnableWindow(ok);
			run1 =run0;
		}
		if( run0==0)	ok=TRUE;
		else			ok=FALSE;
		pt->m_cBtnStart				.EnableWindow(ok);
	}

	pt->m_Thread=0;		pt->m_Stop=0;
	AfxEndThread(0);
	return(0);
}



/////////////////////////////////////////////////////////////////////////////
// 上記スレッドの開始 及び 停止

void
CTDSSample2Dlg::CheckStatusStart()
{
	m_Thread=AfxBeginThread(CheckStatus,(LPVOID)this);
}


void
CTDSSample2Dlg::CheckStatusStop()
{
	if(m_Thread!=0)		m_Stop=1;
}



/////////////////////////////////////////////////////////////////////////////
// 本クラスのメッセージ表示領域への指定メッセージの表示

void CTDSSample2Dlg::AddList(char *str)		// リストに追加
{
	m_cEditList.AddString(str);
}
